<?php defined('_JEXEC') or die('Restricted access');

/**
 * @version 2.0 $Id: ThumbnailUtils.php,v 1.8 2010-08-17 19:25:11 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'LDConfig.php';

class ThumbnailUtils {
	
	private $_linkthumbtype;
	private $_linkthumbaltservice;
	private $_thumbfolderlist;
	private $_linkthumblocalcssclass;
	private $_linkthumbuserbacklinkhtml;
	private $_linkthumbaltimage;
	private $_linkthumbpara1;
	private $_linkthumbpara2;
	private $_linkthumbuserhtml;
	
	/**
	 * Konstruktor lädt die benötigen Konfigurationsparmeter aus LDConfig.
	 */
	public function __construct(LDConfig $ld=null){
		if ($ld == null){
			$ld = new LDConfig();
		}
		$this->_linkthumbtype = $ld->linkthumbtype;
		$this->_linkthumbaltservice = $ld->linkthumbaltservice;
		$this->_thumbfolderlist = $ld->thumbfolderlist;
		$this->_linkthumblocalcssclass = $ld->linkthumblocalcssclass;
		$this->_linkthumbuserbacklinkhtml = $ld->linkthumbuserbacklinkhtml;
		$this->_linkthumbaltimage = $ld->linkthumbaltimage;
		$this->_linkthumbpara1 = $ld->linkthumbpara1;
		$this->_linkthumbpara2 = $ld->linkthumbpara2;
		$this->_linkthumbuserhtml = $ld->linkthumbuserhtml; 
	}
	
	public function getAllSupportedLinkThumbnailServices(){

		return array('thumbshots.de (120x90)',
				// 'livethumb.de (120x90)',
				// 'livethumb.de (200x150)',
				// 'Websnapr.com (92x70 )',
				// 'Websnapr.com (202x152)',
				'mr-thumb.de (120x90)',
				'mr-thumb.de (200x150)',
				'thumber.de (120x90)',
				'artviper.net (120x90)',
				'm-software.de (150x100)',
		 		'thumbshots.com (120x90)' );
	}
	
	function getLocalThumbnailRootDir(){
		return JPATH_ROOT.DS.'images'; 
	}

	function getLocalThumbnailDir(){
		return $this->getLocalThumbnailRootDir().DS.$this->_thumbfolderlist; 
	}
	
	/**
	 * Liefert den benötigen BackLink für den jeweiliegn Link-Thum-Dienst.
	 *
	 * @return String HTML mit dem jeweiligen Code für den Back-Link
	 */
	public function getBackLinkForLinkThumb(){
		if (!$this->isLinkThumbEnable())
		return '';
		switch ($this->_linkthumbtype){
			case 'thumbshots.de (120x90)':
				return '<a href="http://www.thumbshots.de/" target="_blank"><img height="16" alt="Kostenlose Screenshots Ihrer Webseite von Thumbshots.de" src="http://www.thumbshots.de/images/thumbshots_2007.png" width="80" border="0" /></a>';
			// case 'livethumb.de (120x90)':
			// case 'livethumb.de (200x150)':
			// 	return '<a href="http://livethumb.de" target="_blank">liveThumb</a>';
			case 'mr-thumb.de (120x90)':
			case 'mr-thumb.de (200x150)':
				return '<a href="http://www.mr-thumb.de" target="_blank" title="Thumbshots von Mr-Thumb Free Thumbnail Service"><img border="0" src="http://www.mr-thumb.de/images/button.gif" width="80" height="15" alt="Mr-Thumb Free Thumbnail Service"></a>';
			case 'thumber.de (120x90)':
				return '<a target="_blank" href="http://thumber.de" title="Thumbshots by Thumber.de">Thumbshots</a>';
			case 'artviper.net (120x90)':
				return '<a href="http://www.artviper.net" title="artViper designstudio">thumbnails by artViper designstudio</a>';
			case 'm-software.de (150x100)': 
				return '<a href="http://www.m-software.de/thumbshots.html"> <img src="http://www.m-software.de/uploads/thumshots-icon.gif" alt="FreeThumbshots by M-Software.de" width="80" height="15" border="0"></a>';
			case 'thumbshots.com (120x90)':
				return '';
			case 'user':
				return $this->_linkthumbuserbacklinkhtml;
			case 'none';
			default:
				return '';
		}
	}

	/**
	 * Liefert true, wenn ein Link-Thum-Dienst konfiguriert worden ist.
	 *
	 * @return true, wenn ein Link-Tumb-Dienst konfiguriert worden ist
	 * @see $this->_linkthumbtype
	 */
	public function isLinkThumbEnable(){
		if (!$this->_linkthumbaltservice){
			return false;
		}

		switch ($this->_linkthumbtype){
			case 'thumbshots.de (120x90)':
			// case 'livethumb.de (120x90)':
			// case 'livethumb.de (200x150)':
			// case 'Websnapr.com (92x70 )':
			// case 'Websnapr.com (202x152)':
			case 'mr-thumb.de (120x90)':
			case 'mr-thumb.de (200x150)':
			case 'thumber.de (120x90)':
			case 'artviper.net (120x90)':
			case 'm-software.de (150x100)':
			case 'thumbshots.com (120x90)':
			case 'user':
				return true;
			case 'none';
			default:
				return false;
		}
	}
		
	function getCssClassForThumb(){
		switch ($this->_linkthumbtype){
			case 'thumbshots.de (120x90)':
				return 'thumbshots-120';
			// case 'livethumb.de (120x90)':
			// 	return 'thumbshots-120';
			// case 'livethumb.de (200x150)':
			// 	return 'thumbshots-200';
			case 'mr-thumb.de (120x90)':
				return 'thumbshots-120';
			case 'mr-thumb.de (200x150)':
				return 'thumbshots-200';
			case 'thumber.de (120x90)':
				return 'thumbshots-120';
			case 'artviper.net (120x90)':
				'thumbshots-120';
			case 'm-software.de (150x100)':
				return 'thumbshots-150';
			case 'thumbshots.com (120x90)':
				return 'thumbshots-120';
			case 'user':
				return '';
			case 'none';
			default:
				return '';
		}	
	}
	
	private function getCssClassForLokalThumb(){
			return $this->_linkthumblocalcssclass;
	}
	
	/**
	 * Gibt das HTML zurück, welches für das holen des Tumb-Images benötig wird. Welcher 
	 * Dienst dazu benutzt wird, legt die Variable
	 * $this->_linkthumbtype fest.
	 *
	 * @param Weblink Weblink mit 
	 *  url:      URL,deren Thumb-Image angefordert werden soll.
	 *  title:    Titel der Url
	 *  id:       Id des Weblinks
	 *  thumburl: von url abweichende URL für die Anzeige des Thumbnails oder leer, wen identisch zur url
 	 *  image:    Filename des Thumnail-Image oder leer, wenn nicht verfügbar
	 * @return String mit dem HTML zur Darstellung des Thumbnails 
	 */
	public function getThumbForLink(&$weblink){
		require_once(JPATH_COMPONENT.DS.'classes'.DS.'LinkdirectoryURL.php');
		
		if ($this->_linkthumbaltimage){ 	// ggf. Anzeige des alternaitiven Images
			if (($weblink->image != '') || (!$this->isLinkThumbEnable()) ){	
				$cssClass = $this->getCssClassForLokalThumb();
				if ($weblink->image != '') {
					if ($this->_thumbfolderlist == ''){
						$imageRelUrl='images'.DS.$weblink->image;
					}
					else {
						$imageRelUrl='images'.DS.$this->_thumbfolderlist.DS.$weblink->image;
					}
				} else {
					$imageRelUrl='images'.DS.'blank.png';
				}
				return '<img src="'.$imageRelUrl.'" class="'.$cssClass.'" />';
			}
		}
		if (!$this->isLinkThumbEnable()){
			return '';
		}
		if ( ($weblink->thumburl != '') && ($weblink->thumburl != 'http://')){ //  2. Ausdruck: fix für defekte Version 1.3.2 und 1.3.3
			$thumbUrlForService=$weblink->thumburl;
		} else {
			$thumbUrlForService=$weblink->url;
		}
		$aHtml_1='<a href="'.LinkdirectoryURL::getUrlToLink($weblink->url,$weblink->id).'" target="_blank">';
		$aHtml_2='</a>';
		$aHtml_3=' alt="" ';//alt="'.$weblink->title.'" ';
		$cssClass = $this->getCssClassForThumb();
		switch ($this->_linkthumbtype){
			case 'thumbshots.de (120x90)':
				return $aHtml_1.'<img src="http://www.thumbshots.de/cgi-bin/show.cgi?url='.$thumbUrlForService.'" ' .$aHtml_3. ' class="'.$cssClass.'" onload="if (this.width>50) this.border=1; this.alt=\'Vorschau bei Thumbshots.de\';" />'.$aHtml_2;
			// case 'livethumb.de (120x90)':
			//	return $aHtml_1.'<img src="http://livethumb.de/?url='.$url.'&amp;size=120" ' . $aHtml_3 . ' class="thumbshots-120"/>'.$aHtml_2;
			// case 'livethumb.de (200x150)':
			//	return $aHtml_1.'<img src="http://livethumb.de/?url='.$url.'&amp;size=200" ' . $aHtml_3 . ' class="thumbshots-200"/>'.$aHtml_2;
			//case 'Websnapr.com (92x70 )':
			//	$skey=$this->_linkthumbpara2;
			//	return $aHtml_1.'<img src="http://images.websnapr.com/?size=T&amp;key='.$skey.'&amp;url='.$url.'" ' . $aHtml_3 . ' class="thumbshots-92"/>'.$aHtml_2;
			//case 'Websnapr.com (202x152)':
			//	$skey=$this->_linkthumbpara2;
			//	return $aHtml_1.'<img src="http://images.websnapr.com/?size=S&amp;key='.$skey.'&amp;url='.$url.'" ' . $aHtml_3 . ' class="thumbshots-202"/>'.$aHtml_2;
			case 'mr-thumb.de (120x90)':
				return $aHtml_1.'<img src="http://www.mr-thumb.de/kunterbunt.php?url='.$thumbUrlForService.'&amp;size=120" ' . $aHtml_3 . ' class="'.$cssClass.'"/>'.$aHtml_2;
			case 'mr-thumb.de (200x150)':
				return $aHtml_1.'<img src="http://www.mr-thumb.de/kunterbunt.php?url='.$thumbUrlForService.'&amp;size=200" ' . $aHtml_3 . ' class="'.$cssClass.'"/>'.$aHtml_2;
			case 'thumber.de (120x90)':
				return $aHtml_1.'<img src="http://image.thumber.de/?size=M&amp;url='.$thumbUrlForService.'" ' . $aHtml_3 . ' class="'.$cssClass.'"/>'.$aHtml_2;
			case 'artviper.net (120x90)':
				$uid=$this->_linkthumbpara1;
				$skey=$this->_linkthumbpara2;
				return $aHtml_1.'<img src="http://www.artviper.net/screenshots/screener.php?url='.$thumbUrlForService.'&amp;w=120&hamp;=90&amp;sdx=1024&map;sdy=768&amp;q=90&amp;userID='.$uid.'&amp;hash='.md5($weblink->url . $uid . $skey) .'"' . $aHtml_3 . ' class="'.$cssClass.'" />'.$aHtml_2;		
			case 'm-software.de (150x100)':
	    		$baseurl  = "http://www.m-software.de/screenshot/Screenshot.png";
	    		$scale = 6;
	    		$owidth   = 900;
	    		$oheight  = 600;
	    		$width    = $owidth / $scale;
	    		$height   = $oheight / $scale;
	    		$imgurl = $baseurl . "?url=" . urlencode ($thumbUrlForService) . "&scale=" . $scale;
	    		$code     = '<img src="'. $imgurl.'" ' . $aHtml_3 . ' class="'.$cssClass.'"/>';
	   			return $aHtml_1 . $code . $aHtml_2;
			case 'thumbshots.com (120x90)':
				return $aHtml_1.'<img src="http://open.thumbshots.org/image.pxf?url='.urlencode($thumbUrlForService).'" ' . $aHtml_3 . ' class="'.$cssClass.'"/>'.$aHtml_2;
			case 'user':
				return $aHtml_1.sprintf($this->_linkthumbuserhtml,$weblink->url,$weblink->title,$this->_linkthumbpara1,$this->_linkthumbpara2).$aHtml_2;
			case 'none';
			default:
				return '';
		}
	}
}

?>