<?php defined('_JEXEC') or die('Restricted access');

/**
 * @version 2.0 $Id: CategoryHtmlList.php,v 1.13 2010-08-05 21:23:34 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

require_once(JPATH_COMPONENT.DS.'classes'.DS.'LinkdirectoryURL.php');
require_once(JPATH_COMPONENT.DS.'models'.DS.'category.php');

class CategoryHtmlList{
	
	private $_delimiter;
	private $_categoryModel;
	private $_viewCategoryDescription=false;
	
 	public final function __construct($delimiter=' ',$viewCategoryDescription) {
		$this->_delimiter = $delimiter;
		$this->_viewCategoryDescription = $viewCategoryDescription;
   		$this->_categoryModel=JModel::getInstance('Category','LinkDirectory2Model');
   	}
	
	public final function isLinksOrSubCategoriesAvailable(&$row){
		$this->_categoryModel->setId($row->id);
		$totalLinks=$this->_categoryModel->getTotalLinks();
		$totalSubCategories=$this->_categoryModel->getTotalSubCategories();
		return ($totalLinks + $totalSubCategories > 0);
	}
	
	/**
	 * Liefert den übergebenen Text mit den in $this->delimiter gespeicherten Delimiter zurück. 
	 *
	 * @param String $text
	 * @return Text mit Delimiter
	 */
	public final function getTextWithDelimiter(&$text){
		switch ($this->_delimiter) {
			case '[':
				return '['.$text.']';
			case '(':
				return '('.$text.')';
			case '{':
				return '{'.$text.'}';
			case 'lt':
				return '&lt;'.$text.'&gt;';
			case '[_':
				return '['.$text.']'. ' ';
			case '(_':
				return '('.$text.')'. ' ';
			case '{_':
				return '{'.$text.'}'. ' ';
			case 'lt_':
				return '&lt;'.$text.'&gt;'. ' ';				
			case '':
				return $text;
			case ' ': 
			default:	
				return $text . ' ';
		}
	}
	
	public function getTotalLinkAndSubCat($showTotalLinks,$showTotalSubCategories,&$row){
		$out='';
		if ($showTotalLinks) $out.= '<span title="'.JText::_('LD TOOLTIP AMOUNT WEBLINKS').'">'.$row->totalLinks.'</span>';
		if (($showTotalLinks) && ($showTotalSubCategories)) $out.='/';
		if ($showTotalSubCategories) $out.='<span title="'.JText::_('LD TOOLTIPP AMOUNT SUB_WEBCATEGORIES').'">'.$row->totalSubCategories.'</span>';
		if (($showTotalLinks) || ($showTotalSubCategories)) $out='('.$out.')&nbsp;';
		return $out;
	}
	
	/**
	 * Liefert, wenn Description vorhanden ist und auch angeziegt werden soll, die 
	 * Description inkl. einem führenden <br /> zurück. 
	 */
	public final function getCategorieDescr(&$description){
		if (($this->_viewCategoryDescription) && ($description)) {
			return '<br />'.stripslashes($description);
		}
	}
	
	/**
	 * Liefert ein Array mit 
	 * 'link' mit Link zur Kategorie, 
	 * 'src' mit Url des Bildes und 
	 * 'alt' mit dem alterntiven Text 
	 * @param $viewImage wenn true und ein Image verfügbar, wird gefülltes Array zurückgegeben 
	 * @param $row Category mit image, name, linksOrSubCategoriesAvailable, id
	 * @return Array mit 'link', 'src' und 'alt'
	 */
	public final function getCategorieImage($viewImage,&$row){
		$image = array();
		$imageFileName=$row->image;
		$imageAlternative=$row->name;
		if (($viewImage) && ($imageFileName)) {
			if ($row->linksOrSubCategoriesAvailable){
					$image['link'] = JRoute::_(LinkdirectoryURL::getCatURL('categories','viewcat',$row->id));
			} else {
				$image['link'] = '';
			}
			$image['src'] = JUri::base(true) . '/images/stories/'. $imageFileName;
			$image['alt'] = $imageAlternative;
		}
		return $image;
	}
}
?>