<?php defined('_JEXEC') or die('Restricted access');

/**
 * @version 2.0 $Id: view.html.php,v 1.35 2010-08-05 21:17:10 harry Exp $
 * @package Joomla
 * @subpackage H2N Link Directory 2
 * @copyright (C) 2008 - 2009 Harry Klein - www.joomla-hklein.de
 * @Copyright (C) 2006 Soner (pisdoktor) Ekici - www.sonerekici.com
 * @license GNU/GPL, see LICENSE.php
 * 
 * H2N Link Directory 2 is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License 2
 * as published by the Free Software Foundation.
 *
 * H2N Link Directory 2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with EventList; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

jimport( 'joomla.application.component.view');

class LinkDirectory2ViewCategories extends JView {
	function display($tpl = null) {
		require_once JPATH_COMPONENT_ADMINISTRATOR.DS.'LDConfig.php';
		require_once JPATH_COMPONENT.DS.'classes'.DS.'ConfUtils.php';
		require_once JPATH_COMPONENT.DS.'classes'.DS.'ViewUtils.php';
		require_once JPATH_COMPONENT.DS.'classes'.DS.'SearchUtils.php';
		require_once JPATH_COMPONENT.DS.'classes'.DS.'CategoryHtmlList.php';
		require_once JPATH_COMPONENT.DS.'classes'.DS.'CommentHtmlUtils.php';
		
		global $Itemid;
		$this->assign('Itemid',$Itemid);
		$ld = new LDConfig();
		$confUtils = new ConfUtils();	
		$document 	= & JFactory::getDocument();
		$document->addStyleSheet('components'.DS.'com_linkdirectory2'.DS.'css'.DS.'linkdirectory.css');
		$rows_of_category = $this->get( 'SubCategories' );
		$model = $this->getModel();
		$ldPathWay = $model->getLDPathWay(null,ViewUtils::getRootElementLabel());
		$paginationLinks = $this->get( 'paginationLinks');
		$rows_of_links  = $this->get( 'dataLinks' );
		$parent = $this->get('Parent');
		$categoryId = $model->getParentCategoryId();
		$params=ViewUtils::setPageTitleForCategories($parent->name, $ld->displayDynamicPageTitel);
		$this->assign('ldPathWay',	$ldPathWay);
		$addLinkUrl = ViewUtils::getUrlForAddNewLink('categories',$model->getParentCategoryId(),$model->getParentCategoryId());
		$this->assignRef('addLinkUrl',$addLinkUrl);
		$this->assignRef('params',$params);
		parent::display('head');
		$this->assign('categoryId',$categoryId);
		$this->displaySearch();
		$this->assign('copyrigthinfo',$ld->copyrigthinfo);
		$this->assign('version',$confUtils->getCommponetVersion());
		if ( ($categoryId != 0 ) && ( !$parent->name)) {
			parent::display('footer');
			JError::raiseWarning(404, JText::_('CAN NOT FOUND WEBCATEGORY'));
			return;
		}
		
		$this->assignRef('rows_of_category',	$rows_of_category );
		$this->assign('needDetailPage',$confUtils->needDetailPage());
		$this->assign('ratelink',$ld->ratelink);
		
		$this->assign('commentlink',$ld->commentlink);
		$commentSystem = $confUtils->getCommentSystemType();
		switch ($commentSystem){
			case 'jcomment':
					if (!CommentHtmlUtils::isJCommentUseable()){
						$this->assign('commentlink',false);
						$this->assign('commentSystem','none');
					}
			case 'intern':
				$this->assign('commentSystem',$commentSystem);
				break;
			default:
				$this->assign('commentSystem','none');
				break;
		}

		$this->assign('showhits',$ld->showhits);
		$this->assign('showfastlink', $ld->showfastlink);
		$this->assign('ldshowlinkadd',$ld->ldshowlinkadd);		
		$column = $ld->column ;
		if ( ( $categoryId == 0) && ($ld->numberOfColumnForFirstCategory)) {
				$column=$ld->numberOfColumnForFirstCategory;
		}
		$this->assign('amountCategoryColumns',	$column );
		//$this->assign('viewTotalSubCategories',$ld->tslink);
		//$this->assign('viewTotalLinks',$ld->tlink);
		
		$this->assignRef('paginationLinks', $paginationLinks);
		$this->assignRef( 'rows_of_links',	$rows_of_links );
		$this->tabclass = array( 'link1', 'link2' );
		$this->assign('showCategorieDescr',$ld->catdesc);
		//$this->assign('catimage',$ld->catimage);
		$this->assign('maxSubCategories',$ld->sublimit);
		
		$this->assign('showlongdescription',$ld->ldlonglist);
		$this->assign('ldshowcatonlist',$ld->ldshowcatonlist);
		$this->assignRef('parentDescription',$parent->description);
		$this->assign('badlink',$ld->badlink);
		
		$html = new CategoryHtmlList($ld->categoryDelimiter,$ld->catdesc); 
		if ($column == 1) {
			$categoryModel=JModel::getInstance('Category','LinkDirectory2Model');
			foreach ($rows_of_category as $rowOfCategory){
				$rowOfCategory->name = $html->getTextWithDelimiter($rowOfCategory->name);
				$rowOfCategory->totalLinkAndSubCatHtml = $html->getTotalLinkAndSubCat($ld->tlink, $ld->tslink, $rowOfCategory);
				$rowOfCategory->linksOrSubCategoriesAvailable=$html->isLinksOrSubCategoriesAvailable($rowOfCategory);
				$categoryModel->setId($rowOfCategory->id);
			}
			parent::display('onecolumn');
		} else {
			$categoryModel=JModel::getInstance('Category','LinkDirectory2Model');
			foreach ($rows_of_category as $rowOfCategory){
				$rowOfCategory->descriptionHtml = $html->getCategorieDescr($rowOfCategory->description);
				$rowOfCategory->totalLinkAndSubCatHtml = $html->getTotalLinkAndSubCat($ld->tlink, $ld->tslink, $rowOfCategory);
				$categoryModel->setId($rowOfCategory->id);
				$rowOfCategory->linksOrSubCategoriesAvailable=$html->isLinksOrSubCategoriesAvailable($rowOfCategory);
				$rowOfCategory->image = $html->getCategorieImage($ld->catimage,$rowOfCategory);
			}
			if ($column == 11){
				parent::display('one');
			} else {
				parent::display($tpl);
			}
		}
		parent::display('links');
		parent::display('footer');
		
	}
	
	private function displaySearch(){
		require_once JPATH_COMPONENT.DS.'classes'.DS.'ConfUtils.php';
		require_once JPATH_COMPONENT.DS.'classes'.DS.'SearchUtils.php';
		
		$confUtils = new ConfUtils();
		
		$this->assign('searchEnable',$confUtils->isSearchEnable());
		$this->assign('linkSearchEnable',$confUtils->isLinkSearchEnable());
		$this->assign('isCategorySearchEnable',$confUtils->isCategorySearchEnable());
		SearchUtils::setSearchParameterIntoView($this);
		parent::display('search');
	}
	
}
?>
